diff --git a/test/unit/schema_files_test.rb b/test/unit/schema_files_test.rb
index 2d10237de..879cd977d 100644
--- a/test/unit/schema_files_test.rb
+++ b/test/unit/schema_files_test.rb
@@ -1475,12 +1475,100 @@ class SchemaFilesTest < Minitest::Test
     # are required-but-nullable in the schema.
     producer_required = %w[
       schema schema_version ok running pid uptime_sec pid_file log_file
-      service_installed service_enabled unit_path current_version update_nudge
+      service_installed service_enabled unit_path binary binary_version
+      consistent current_version update_nudge
     ].sort
     assert_equal producer_required, schema_required,
                  "schema/producer required-key drift in hive-daemon-status.v1.json"
   end
 
+  # ── hive-web-status ─────────────────────────────────────────────────────
+
+  def test_hive_web_status_schema_file_exists_and_is_valid_json
+    path = Hive::Schemas.schema_path("hive-web-status")
+    assert File.exist?(path), "schema file missing: #{path}"
+
+    doc = JSON.parse(File.read(path))
+    assert_equal "https://json-schema.org/draft/2020-12/schema", doc["$schema"]
+    assert_equal "hive-web-status",
+                 doc.dig("$defs", "SuccessPayload", "properties", "schema", "const")
+    assert_equal 1,
+                 doc.dig("$defs", "SuccessPayload", "properties", "schema_version", "const")
+  end
+
+  def test_hive_web_status_required_keys_match_producer_emission
+    doc = JSON.parse(File.read(Hive::Schemas.schema_path("hive-web-status")))
+    schema_required = doc.dig("$defs", "SuccessPayload", "required").sort
+    # Mirrors the producer's JSON.generate call in Hive::Commands::Web#status_web_service.
+    producer_required = %w[
+      schema schema_version ok running pid uptime_sec pid_file
+      service_installed service_enabled unit_path app_dir bind port
+    ].sort
+    assert_equal producer_required, schema_required,
+                 "schema/producer required-key drift in hive-web-status.v1.json"
+  end
+
+  def test_hive_web_status_payload_validates_against_published_schema
+    schemer = JSONSchemer.schema(JSON.parse(File.read(Hive::Schemas.schema_path("hive-web-status"))))
+    payload = {
+      "schema" => "hive-web-status",
+      "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-status"),
+      "ok" => true,
+      "running" => false,
+      "pid" => nil,
+      "uptime_sec" => nil,
+      "pid_file" => "/tmp/.web.pid",
+      "service_installed" => true,
+      "service_enabled" => true,
+      "unit_path" => "/home/you/.config/systemd/user/hive-web.service",
+      "app_dir" => "/home/you/.local/share/hive/web",
+      "bind" => "127.0.0.1",
+      "port" => 4567
+    }
+    errors = schemer.validate(payload).map { |e| e["error"] }
+    assert_empty errors,
+                 "hive-web-status success payload must validate (errors: #{errors.inspect})"
+  end
+
+  # ── hive-setup ──────────────────────────────────────────────────────────
+
+  def test_hive_setup_schema_file_exists_and_is_valid_json
+    path = Hive::Schemas.schema_path("hive-setup")
+    assert File.exist?(path), "schema file missing: #{path}"
+
+    doc = JSON.parse(File.read(path))
+    assert_equal "https://json-schema.org/draft/2020-12/schema", doc["$schema"]
+    assert_equal "hive-setup",
+                 doc.dig("$defs", "SuccessPayload", "properties", "schema", "const")
+    assert_equal 1,
+                 doc.dig("$defs", "SuccessPayload", "properties", "schema_version", "const")
+  end
+
+  def test_hive_setup_success_payload_validates_against_published_schema
+    schemer = JSONSchemer.schema(JSON.parse(File.read(Hive::Schemas.schema_path("hive-setup"))))
+    payload = {
+      "schema" => "hive-setup",
+      "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-setup"),
+      "ok" => true,
+      "backends" => [ "claude", "codex" ],
+      "deps" => [
+        { "name" => "ruby", "ok" => true, "blocked" => false, "found" => "3.4.10",
+          "required" => "3.4.x", "message" => "ok", "fix" => nil },
+        { "name" => "claude", "ok" => false, "blocked" => true, "found" => nil,
+          "required" => ">= 2.1.118", "message" => "missing", "fix" => "brew install claude && claude login" }
+      ],
+      "steps" => [
+        { "name" => "deps", "ok" => true, "message" => "checked 2 dependencies" },
+        { "name" => "web", "ok" => true, "message" => "web health OK" }
+      ],
+      "web_url" => "http://127.0.0.1:4567",
+      "warnings" => [ "claude: brew install claude && claude login" ]
+    }
+    errors = schemer.validate(payload).map { |e| e["error"] }
+    assert_empty errors,
+                 "hive-setup success payload must validate (errors: #{errors.inspect})"
+  end
+
   # ── hive-daemon-stop ───────────────────────────────────────────────────
 
   def test_hive_daemon_stop_schema_file_exists_and_is_valid_json
diff --git a/test/unit/web/config_test.rb b/test/unit/web/config_test.rb
index a9ed23895..106a8158b 100644
--- a/test/unit/web/config_test.rb
+++ b/test/unit/web/config_test.rb
@@ -63,4 +63,40 @@ class WebConfigTest < Minitest::Test
   def test_blank_web_session_secret_file_is_rejected
     assert_web_config_error({ "session_secret_file" => "  " }, /web\.session_secret_file/)
   end
+
+  def test_web_auth_mode_defaults_to_owner
+    with_tmp_global_config do
+      assert_equal "owner", Hive::Config.load_global_web["auth_mode"]
+    end
+  end
+
+  def test_invalid_web_auth_mode_is_rejected
+    assert_web_config_error({ "auth_mode" => "open" }, /web\.auth_mode/)
+  end
+
+  def test_non_boolean_unsafe_public_no_auth_is_rejected
+    assert_web_config_error({ "unsafe_public_no_auth" => "yes" }, /web\.unsafe_public_no_auth/)
+  end
+
+  def test_local_web_no_auth_truth_table
+    refute Hive::Config.local_web_no_auth?({ "auth_mode" => "owner" })
+    assert Hive::Config.local_web_no_auth?({ "auth_mode" => "loopback" })
+    refute Hive::Config.local_web_no_auth?({})
+    refute Hive::Config.local_web_no_auth?({ "auth_mode" => nil })
+  end
+
+  def test_web_bind_loopback_truth_table
+    assert Hive::Config.web_bind_loopback?("127.0.0.1")
+    assert Hive::Config.web_bind_loopback?("127.0.0.0")
+    assert Hive::Config.web_bind_loopback?("127.255.255.255")
+    assert Hive::Config.web_bind_loopback?("::1")
+    assert Hive::Config.web_bind_loopback?("localhost")
+    assert Hive::Config.web_bind_loopback?("LOCALHOST")
+    assert Hive::Config.web_bind_loopback?("")
+    assert Hive::Config.web_bind_loopback?(nil)
+
+    refute Hive::Config.web_bind_loopback?("0.0.0.0")
+    refute Hive::Config.web_bind_loopback?("192.168.1.10")
+    refute Hive::Config.web_bind_loopback?("example.com")
+  end
 end
diff --git a/test/unit/web/web_command_test.rb b/test/unit/web/web_command_test.rb
index 11de4ab06..e9a37f680 100644
--- a/test/unit/web/web_command_test.rb
+++ b/test/unit/web/web_command_test.rb
@@ -48,6 +48,80 @@ class WebCommandTest < Minitest::Test
       assert_empty err, "an https origin implies a fronting proxy — no warning"
     end
   end
+
+  # ── U1: local loopback auth policy guard ───────────────────────────────
+
+  def test_non_loopback_bind_with_loopback_auth_is_refused
+    with_tmp_global_config do
+      command = Hive::Commands::Web.new
+      cfg = { "auth_mode" => "loopback", "unsafe_public_no_auth" => false }
+      err = assert_raises(Hive::ConfigError) do
+        command.send(:refuse_unsafe_public_bind, "0.0.0.0", cfg)
+      end
+      assert_match(/refusing to bind/, err.message)
+      assert_match(/loopback/, err.message)
+    end
+  end
+
+  def test_non_loopback_bind_with_owner_auth_is_accepted
+    with_tmp_global_config do
+      command = Hive::Commands::Web.new
+      # "owner" is the default and keeps Docker/hivebox behavior (0.0.0.0).
+      command.send(:refuse_unsafe_public_bind, "0.0.0.0", { "auth_mode" => "owner", "unsafe_public_no_auth" => false })
+      command.send(:refuse_unsafe_public_bind, "0.0.0.0", {}) # missing auth_mode = owner default
+    end
+  end
+
+  def test_non_loopback_bind_with_unsafe_flag_is_accepted
+    with_tmp_global_config do
+      command = Hive::Commands::Web.new
+      command.send(:refuse_unsafe_public_bind, "0.0.0.0", { "auth_mode" => "loopback", "unsafe_public_no_auth" => true })
+    end
+  end
+
+  def test_loopback_bind_is_always_accepted
+    with_tmp_global_config do
+      command = Hive::Commands::Web.new
+      command.send(:refuse_unsafe_public_bind, "127.0.0.1", { "auth_mode" => "loopback", "unsafe_public_no_auth" => false })
+      command.send(:refuse_unsafe_public_bind, "::1", { "auth_mode" => "loopback", "unsafe_public_no_auth" => false })
+      command.send(:refuse_unsafe_public_bind, "localhost", { "auth_mode" => "loopback", "unsafe_public_no_auth" => false })
+    end
+  end
+
+  # ── U2: subcommand routing + status envelope ────────────────────────────
+
+  def test_unknown_subcommand_raises_usage
+    err = assert_raises(Hive::InvalidTaskPath) do
+      Hive::Commands::Web.new("bogus").call
+    end
+    assert_match(/unknown subcommand/, err.message)
+  end
+
+  def test_status_json_emits_hive_web_status_envelope
+    with_tmp_global_config do
+      command = Hive::Commands::Web.new("status", json: true)
+      out, = capture_io { command.call }
+      payload = JSON.parse(out)
+      assert_equal "hive-web-status", payload["schema"]
+      assert_equal Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-status"), payload["schema_version"]
+      assert_equal true, payload["ok"]
+      assert_equal false, payload["running"]
+      assert_nil payload["pid"]
+      assert payload.key?("app_dir"), "status must report the resolved app dir"
+      assert_equal "127.0.0.1", payload["bind"]
+      assert_equal 4567, payload["port"]
+    end
+  end
+
+  def test_status_bare_text_reports_not_running_and_exits_nonzero
+    with_tmp_global_config do
+      command = Hive::Commands::Web.new("status")
+      err = assert_raises(Hive::Error) do
+        capture_io { command.call }
+      end
+      assert_match(/web not running/, err.message)
+    end
+  end
   # Drive the full "app found" path with a stub Rails app: db:prepare
   # failure raises typed guidance (never a raw backtrace looping under the
   # container supervisor), and a passing prepare reaches Kernel.exec with
diff --git a/web/app/controllers/application_controller.rb b/web/app/controllers/application_controller.rb
index 2a1e5e28f..6a5afe55e 100644
--- a/web/app/controllers/application_controller.rb
+++ b/web/app/controllers/application_controller.rb
@@ -11,7 +11,7 @@ class ApplicationController < ActionController::Base
 
   before_action :require_login
 
-  helper_method :current_login
+  helper_method :current_login, :local_auth_mode?, :container_managed?
 
   # Hive's typed errors are operator-readable by design ("task not in stage",
   # "invalid clone URL"). Render them on an error page instead of a blank
@@ -49,7 +49,34 @@ class ApplicationController < ActionController::Base
     session[:github_login]
   end
 
+  # Resolved global web config, memoized per request. The Rails tier reads the
+  # same resolved config the CLI refuses on (Hive::Config.load_global_web), so
+  # the loopback no-auth policy cannot drift between startup refusal and
+  # per-request gating.
+  def web_config
+    @web_config ||= Hive::Config.load_global_web
+  end
+
+  # True when the web tier runs in local loopback no-auth mode
+  # (`web.auth_mode: loopback`). Drives the auth-disabled banner (U6) and the
+  # require_login skip (U1).
+  def local_auth_mode?
+    Hive::Config.local_web_no_auth?(web_config)
+  end
+
+  # True when the web tier runs under the hivebox container supervisor (the
+  # daemon is Supervisor-managed, not a per-user systemd/launchd service).
+  # The supervisor sets HIVEBOX_SUPERVISOR_PID on its children; local mode
+  # starts the Rails server directly and leaves it unset.
+  def container_managed?
+    ENV["HIVEBOX_SUPERVISOR_PID"].to_i > 0
+  end
+
   def require_login
+    # Loopback no-auth mode: no GitHub owner gate at all. Still allow an
+    # explicit login (the optional owner path stays usable locally).
+    return if local_auth_mode?
+
     return redirect_to login_path unless current_login
 
     # Sessions must track the CURRENT owner, not the owner at sign-in time:
@@ -57,7 +84,7 @@ class ApplicationController < ActionController::Base
     # old sessions alive with repo-scoped credentials. The dev/test seam
     # signs in arbitrary logins, so it is exempt only where real GitHub auth
     # is (local envs).
-    auth = Hive::Web::GithubAuth.new(config: Hive::Config.load_global_web)
+    auth = Hive::Web::GithubAuth.new(config: web_config)
     return if auth.owner?(current_login)
     return if Rails.env.local? && session[:github_token].blank?
 
diff --git a/web/app/controllers/daemon_controller.rb b/web/app/controllers/daemon_controller.rb
new file mode 100644
index 000000000..e9b4da8bc
--- /dev/null
+++ b/web/app/controllers/daemon_controller.rb
@@ -0,0 +1,73 @@
+require "open3"
+require "tempfile"
+require "hive/invoked_binary"
+
+# Web repair surface for the daemon (U5). `POST /daemon/repair` runs the
+# bounded repair as a lifecycle verb — `hive daemon install --force` (rewrites
+# the unit's ExecStart to the resolved binary and restarts) then
+# `hive daemon start` — NOT through the dispatch queue, matching how the
+# task Drop/Approve mutations are in-process. CSRF-protected and
+# owner/loopback-gated like every other mutation route.
+class DaemonController < ApplicationController
+  # The repair command runner seam (mirrors SessionsController.http_client).
+  # Tests inject a recorder; production uses the default bounded subprocess.
+  class_attribute :repair_runner, default: nil
+
+  DAEMON_REPAIR_TIMEOUT_SEC = Integer(ENV.fetch("HIVEBOX_DAEMON_REPAIR_TIMEOUT_SEC", 120))
+
+  def repair
+    # The repair verb rewrites a per-user systemd/launchd unit and restarts
+    # it — lifecycle actions that only make sense in local/service-managed
+    # mode. In the Docker/hivebox path the daemon is Supervisor-managed
+    # (no per-user unit exists), so `install`/`start` can't repair it; tell
+    # the operator the real remediation instead of misfiring lifecycle verbs.
+    if container_managed?
+      redirect_to root_path,
+                  notice: "The daemon is managed by the container supervisor — restart the container to repair it."
+      return
+    end
+
+    bin = Hive::InvokedBinary.path || "hive"
+    commands = [
+      [ bin, "daemon", "install", "--force" ],
+      [ bin, "daemon", "start" ]
+    ]
+
+    if self.class.repair_runner
+      self.class.repair_runner.call(commands)
+    else
+      commands.each { |argv| bounded_run(argv) }
+    end
+
+    redirect_to root_path, notice: "Daemon repair completed"
+  end
+
+  private
+
+  # Bounded subprocess discipline shared with ReposController#clone! and
+  # TasksController#bounded_diff: own process group, hard wall-clock deadline,
+  # output to a tempfile, typed error page on timeout/failure.
+  def bounded_run(argv)
+    log = Tempfile.create("hivebox-daemon-repair")
+    pid = Process.spawn(*argv, pgroup: true, out: log.path, err: log.path)
+    deadline = Process.clock_gettime(Process::CLOCK_MONOTONIC) + DAEMON_REPAIR_TIMEOUT_SEC
+    status = nil
+    loop do
+      _, status = Process.waitpid2(pid, Process::WNOHANG)
+      break if status
+
+      if Process.clock_gettime(Process::CLOCK_MONOTONIC) > deadline
+        Process.kill("KILL", -pid) rescue nil
+        Process.waitpid2(pid) rescue nil
+        raise Hive::Error, "daemon repair timed out after #{DAEMON_REPAIR_TIMEOUT_SEC}s"
+      end
+      sleep 0.2
+    end
+    return if status.success?
+
+    raise Hive::Error, "daemon repair failed: #{File.read(log.path).strip}"
+  ensure
+    log&.close
+    File.unlink(log.path) if log && File.exist?(log.path)
+  end
+end
diff --git a/web/app/controllers/health_controller.rb b/web/app/controllers/health_controller.rb
index cda67e408..4cd5f8436 100644
--- a/web/app/controllers/health_controller.rb
+++ b/web/app/controllers/health_controller.rb
@@ -3,29 +3,20 @@ require "hive/pid_file"
 class HealthController < ApplicationController
   skip_before_action :require_login
 
-  # Reads the daemon's pidfile the same way `hive daemon status` does —
-  # stale files and reused PIDs don't count as alive.
-  class DaemonProbe
-    include Hive::PidFile
-
-    def pid_file
-      File.join(Hive::Paths.state_home, ".daemon.pid")
-    end
-  end
-
   # `/health` is web liveness (also the supervisor/installer smoke), while
   # `/health?deep=1` is the container readiness probe: the box is only
   # useful when the daemon child is running too — a crashlooping daemon
   # must turn the container unhealthy, not sit invisible behind a green
-  # web tier.
+  # web tier. Deep health also carries the U5 binary-consistency fields so
+  # the readiness gate and the status card read the same data.
   def show
     return render json: { ok: true } unless params[:deep].present?
 
-    daemon_pid = DaemonProbe.new.read_live_pid
-    if daemon_pid
-      render json: { ok: true, daemon: { running: true, pid: daemon_pid } }
+    daemon = DaemonHealth.new.snapshot
+    if daemon[:running]
+      render json: { ok: true, daemon: daemon }
     else
-      render json: { ok: false, daemon: { running: false } }, status: :service_unavailable
+      render json: { ok: false, daemon: daemon }, status: :service_unavailable
     end
   end
 end
diff --git a/web/app/controllers/sessions_controller.rb b/web/app/controllers/sessions_controller.rb
index f1fecfd8c..769316ee5 100644
--- a/web/app/controllers/sessions_controller.rb
+++ b/web/app/controllers/sessions_controller.rb
@@ -16,6 +16,12 @@ class SessionsController < ApplicationController
   def new
     return redirect_to root_path if current_login
 
+    # Loopback no-auth mode: the first-run claim flow is not just broken — it
+    # is unnecessary. Show an explicit "auth disabled locally" notice instead
+    # of a device-flow button that can never complete (no owner gate).
+    @auth_disabled = local_auth_mode?
+    return if @auth_disabled
+
     # Surface a misconfigured box on the page itself — a sign-in button that
     # errors only after the click is a broken first-run.
     @configured = github_auth.configured?
diff --git a/web/app/controllers/status_controller.rb b/web/app/controllers/status_controller.rb
index c44440a83..0d673db5c 100644
--- a/web/app/controllers/status_controller.rb
+++ b/web/app/controllers/status_controller.rb
@@ -2,5 +2,6 @@ class StatusController < ApplicationController
   def index
     @payload = StatusBroadcaster.snapshot
     @projects = @payload.fetch("projects", [])
+    @daemon = DaemonHealth.new.snapshot
   end
 end
diff --git a/web/app/models/daemon_health.rb b/web/app/models/daemon_health.rb
new file mode 100644
index 000000000..ff4e2db99
--- /dev/null
+++ b/web/app/models/daemon_health.rb
@@ -0,0 +1,27 @@
+require "hive/pid_file"
+require "hive/daemon/consistency"
+
+# Shared daemon health snapshot for the web tier: reads the daemon's pidfile
+# (same liveness + ownership checks as `hive daemon status`) and layers the
+# U5 binary-consistency probe on top. Used by the deep health endpoint and the
+# status-page daemon card so the two surfaces can never disagree.
+class DaemonHealth
+  include Hive::PidFile
+
+  def pid_file
+    File.join(Hive::Paths.state_home, ".daemon.pid")
+  end
+
+  def snapshot
+    pid = read_live_pid
+    consistency = Hive::Daemon::Consistency.new(pid: pid).probe
+    {
+      running: !pid.nil?,
+      pid: pid,
+      binary_version: consistency["binary_version"],
+      consistent: consistency["consistent"]
+    }
+  rescue StandardError
+    { running: false, pid: nil, binary_version: Hive::VERSION, consistent: nil }
+  end
+end
diff --git a/web/app/views/layouts/application.html.erb b/web/app/views/layouts/application.html.erb
index 77e0c5f9d..2f6925156 100644
--- a/web/app/views/layouts/application.html.erb
+++ b/web/app/views/layouts/application.html.erb
@@ -24,6 +24,9 @@
     <header class="topbar">
       <div class="topbar-inner">
         <%= link_to "hivebox", root_path, class: "brand" %>
+        <% if local_auth_mode? %>
+          <span class="local-mode-badge" title="web.auth_mode: loopback — no GitHub login required on 127.0.0.1">local mode — no auth</span>
+        <% end %>
         <% if current_login %>
           <nav aria-label="Primary">
             <%= link_to "Status", root_path, class: nav_class(:status) %>
diff --git a/web/app/views/sessions/new.html.erb b/web/app/views/sessions/new.html.erb
index c83e881b9..5537ecbb9 100644
--- a/web/app/views/sessions/new.html.erb
+++ b/web/app/views/sessions/new.html.erb
@@ -1,7 +1,12 @@
 <% content_for(:title, "hivebox — sign in") %>
 <div class="card auth-card">
   <h1>hivebox</h1>
-  <% if @configured %>
+  <% if @auth_disabled %>
+    <p>Auth is disabled — this box runs in local mode
+      (<code>web.auth_mode: loopback</code>). The web UI needs no sign-in on
+      <code>127.0.0.1</code>; GitHub sign-in remains available only if you
+      switch <code>web.auth_mode</code> back to <code>owner</code>.</p>
+  <% elsif @configured %>
     <% if @claimable %>
       <p>Fresh box — the first GitHub sign-in becomes its owner.</p>
       <p class="muted">You'll get a short code to type at github.com/login/device
diff --git a/web/app/views/status/_daemon_health.html.erb b/web/app/views/status/_daemon_health.html.erb
new file mode 100644
index 000000000..a701278ed
--- /dev/null
+++ b/web/app/views/status/_daemon_health.html.erb
@@ -0,0 +1,28 @@
+<%# Daemon health card (U5/U6): running/version/consistency from the shared
+    DaemonHealth snapshot, plus a bounded Repair action that posts to the
+    lifecycle route (not the dispatch queue). %>
+<% daemon ||= @daemon %>
+<section class="project-section daemon-health" id="daemon-health">
+  <div class="project-title">
+    <h2>Daemon</h2>
+    <% if daemon[:running] %>
+      <span class="muted">v<%= daemon[:binary_version] %></span>
+    <% end %>
+  </div>
+  <div class="daemon-health-status">
+    <% if daemon[:running] %>
+      <span class="status-dot status-dot-running" title="running (pid <%= daemon[:pid] %>)"></span>
+      <span>running</span>
+      <% if daemon[:consistent] == false %>
+        <span class="daemon-health-drift" role="alert">binary/version drift detected — repair to match the CLI</span>
+      <% end %>
+    <% else %>
+      <span class="status-dot status-dot-idle"></span>
+      <span>not running</span>
+    <% end %>
+  </div>
+  <% if !container_managed? && (!daemon[:running] || daemon[:consistent] == false) %>
+    <%= button_to "Repair daemon", daemon_repair_path, class: "btn btn-sm",
+          form_class: "inline-form", data: { turbo_submits_with: "Repairing…" } %>
+  <% end %>
+</section>
diff --git a/web/app/views/status/index.html.erb b/web/app/views/status/index.html.erb
index 25bcdf793..6308337e6 100644
--- a/web/app/views/status/index.html.erb
+++ b/web/app/views/status/index.html.erb
@@ -26,6 +26,8 @@
   </aside>
   <div class="status-main">
 
+<%= render "status/daemon_health", daemon: @daemon %>
+
 <%# data-turbo-permanent: a morph must never touch the composer — it holds
     typed-but-unsent idea text and staged image attachments (Stimulus state
     the server can't re-render). %>
diff --git a/web/config/routes.rb b/web/config/routes.rb
index 659576df3..61017cf34 100644
--- a/web/config/routes.rb
+++ b/web/config/routes.rb
@@ -3,6 +3,10 @@ Rails.application.routes.draw do
   get "health" => "health#show"
   get "up" => "rails/health#show", as: :rails_health_check
 
+  # Daemon health + bounded repair (U5). The repair is a lifecycle verb,
+  # not a workflow verb — it runs in-process, CSRF-protected + auth-gated.
+  post "daemon/repair" => "daemon#repair", as: :daemon_repair
+
   # GitHub device-flow sign-in (RFC 8628). Start is a POST (it creates a
   # GitHub device code); the wait page polls the grant.
   # Development/test only: the auth seam Capybara logs in through (and dev
diff --git a/web/test/e2e/golden_path_e2e.rb b/web/test/e2e/golden_path_e2e.rb
index 5d6c83021..950354ed5 100644
--- a/web/test/e2e/golden_path_e2e.rb
+++ b/web/test/e2e/golden_path_e2e.rb
@@ -149,8 +149,47 @@ class GoldenPathE2E < ApplicationSystemTestCase
                     "the fake agent's commit must be a real commit in a real worktree"
   end
 
+  test "local loopback mode: no login, idea auto-dispatches through the daemon" do
+    # U1 / R13 local path: loopback no-auth skips the GitHub owner gate, so
+    # the status grid renders directly (no claim flow) and the daemon still
+    # auto-dispatches a dropped idea — the web↔daemon shared source of truth
+    # the definition-of-done requires, exercised WITHOUT the Docker claim flow.
+    configure_loopback_no_auth!
+
+    visit "/"
+    assert_no_current_path "/login", "loopback no-auth must not redirect to /login"
+    assert_selector "#projects", wait: 15
+
+    # --- Sample idea -------------------------------------------------------
+    fill_in "New idea", with: "Local mode sample idea"
+    find(".composer select[name='project']").find("option[value='#{@project}']").select_option
+    click_button "Add idea"
+    assert_selector ".task-row", text: "Local mode sample idea", wait: 10
+
+    # No manual claim or login: the daemon drives the task forward on its own.
+    assert_selector ".stage-badge", text: "execute", wait: 90
+    assert_selector ".task-meta", text: "Ready to open PR", wait: 90
+  end
+
   private
 
+  # Local loopback no-auth config (U1): the same block `hive setup` /
+  # `hive web install` persist. Unlike configure_owner! (Docker claimable
+  # box), this sets auth_mode=loopback + a loopback bind so require_login
+  # skips the owner gate entirely.
+  def configure_loopback_no_auth!
+    path = File.join(ENV["HIVE_HOME"], "config.yml")
+    data = File.exist?(path) ? YAML.safe_load_file(path) : {}
+    data ||= {}
+    data["web"] = {
+      "origin" => "http://127.0.0.1:4567",
+      "bind" => "127.0.0.1",
+      "auth_mode" => "loopback",
+      "github" => { "client_id" => "client" }
+    }
+    File.write(path, data.to_yaml)
+  end
+
   # The status grid is Turbo-replaced while the daemon advances tasks. Read the
   # slug from a single current-DOM query instead of retaining a Capybara element.
   def task_slug_from_grid!(title, timeout: 10)
diff --git a/web/test/integration/auth_local_mode_test.rb b/web/test/integration/auth_local_mode_test.rb
new file mode 100644
index 000000000..977203f21
--- /dev/null
+++ b/web/test/integration/auth_local_mode_test.rb
@@ -0,0 +1,62 @@
+require "test_helper"
+
+# U1 — local loopback auth policy. When `web.auth_mode: loopback` is set (the
+# mode `hive setup` / `hive web install` write for the first-class local
+# install), the web tier skips the GitHub owner gate entirely: `/` renders
+# without a login. The non-loopback half of the policy is enforced in the CLI
+# (`Hive::Commands::Web#refuse_unsafe_public_bind`), so the Rails tier only
+# needs to prove the config-derived predicate agrees.
+class AuthLocalModeTest < ActionDispatch::IntegrationTest
+  def write_loopback_config!(bind: "127.0.0.1", auth_mode: "loopback", unsafe: false)
+    path = File.join(ENV["HIVE_HOME"], "config.yml")
+    data = File.exist?(path) ? YAML.safe_load_file(path) : {}
+    data ||= {}
+    data["web"] = {
+      "bind" => bind,
+      "origin" => "http://127.0.0.1:4567",
+      "auth_mode" => auth_mode,
+      "unsafe_public_no_auth" => unsafe,
+      "github" => { "client_id" => "client" }
+    }
+    File.write(path, data.to_yaml)
+  end
+
+  test "loopback no-auth renders the status grid without login" do
+    write_loopback_config!
+    get "/"
+    assert_response :success, "loopback no-auth mode must render / without redirecting to /login"
+  end
+
+  test "loopback no-auth does not create a session" do
+    write_loopback_config!
+    get "/"
+    assert_nil session[:github_login], "no-auth mode must not fabricate a login"
+  end
+
+  test "owner mode still redirects unauthenticated requests to login" do
+    write_loopback_config!(auth_mode: "owner")
+    get "/"
+    assert_redirected_to "/login", "owner mode must keep the existing auth gate"
+  end
+
+  test "login page reflects auth disabled in loopback mode" do
+    write_loopback_config!
+    get "/login"
+    assert_response :success
+    assert_match(/auth is disabled/i, response.body)
+    assert_select "form[action='/auth/github']", 0,
+                  "the device-flow button must not render when auth is disabled locally"
+  end
+
+  test "config-derived predicate agrees with the CLI refusal guard" do
+    write_loopback_config!
+    cfg = Hive::Config.load_global_web
+    assert Hive::Config.local_web_no_auth?(cfg), "loopback config must resolve to no-auth"
+    refute Hive::Config.web_bind_loopback?("0.0.0.0"),
+           "a non-loopback bind under loopback mode is what the CLI refuses"
+
+    # The CLI guard refuses exactly when the app would otherwise run
+    # ownerless on a public interface.
+    assert Hive::Config.local_web_no_auth?(cfg) && !Hive::Config.web_bind_loopback?("0.0.0.0")
+  end
+end
